--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_tcp-host.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_tcp-host.c	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,162 @@
+/* Name: mausb_tcp-host.c 
+ * Description: The host side media specific driver to allow media agnostic 
+ * packets over tcp/ip. 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+ 
+#include <linux/module.h> 
+#include <linux/init.h> 
+ 
+#include "mausb_tcp.h" 
+/*
+void mausb_free_ms_pkt(struct ms_pkt *pkt) 
+{ 
+ int i; 
+ void *current_buf; 
+ 
+ for (i = 0; i < pkt->nents; ++i) { 
+ current_buf = pkt->kvec[i].iov_base; 
+ if (NULL != current_buf) { 
+ kfree(current_buf); 
+ } else { 
+ pr_debug("%s: cannot find buffer for kvec #%i in" 
+ " ms_pkt at %p\n", __func__, i, pkt->kvec); 
+ } 
+ } 
+ 
+ kfree(pkt); 
+ 
+ return; 
+} */
+ 
+struct mausb_tcp_medium *host_tcp_medium; 
+ 
+int mausb_tcp_host_thread(void *data) 
+{ 
+ return mausb_tcp_receive_loop(host_tcp_medium); 
+} 
+ 
+int mausb_tcp_host_add_tx_pair(struct mausb_transfer_pair *ma_pair) 
+{ 
+ return mausb_tcp_add_tx_pair(ma_pair, host_tcp_medium); 
+} 
+ 
+static struct mausb_ms_ops ms_ops = { 
+ .add_transfer_pair = &mausb_tcp_host_add_tx_pair, 
+ .drop_transfer_pair = &mausb_tcp_drop_tx_pair, 
+ .pkt_destructor = &mausb_free_ms_pkt 
+}; 
+ 
+static struct mausb_ms_drv ms_driver = { 
+ .ops = &ms_ops 
+}; 
+ 
+static int mausb_tcp_host_connect(int on) 
+{ 
+ int ret; 
+ 
+ if (on) { 
+ ret = kernel_bind(host_tcp_medium->setup_socket, 
+ &host_tcp_medium->addr, 
+ sizeof(host_tcp_medium->addr_in)); 
+ 
+ ret = kernel_listen(host_tcp_medium->setup_socket, 
+ MAUSB_TCP_MAX_NUM_CHANNELS); 
+ pr_debug("%s: kernel_listen returned %i\n", __func__, ret); 
+ 
+ ret = kernel_accept(host_tcp_medium->setup_socket, 
+ &host_tcp_medium->socket, 0); 
+ pr_debug("%s:kernel_accept returned %i\n", __func__, ret); 
+ 
+ if (0 > ret) 
+ return ret; 
+ 
+ if (NULL == host_tcp_medium->recv_task) { 
+ host_tcp_medium->recv_task = kthread_run( 
+ mausb_tcp_host_thread, NULL, 
+ "mausb_tcp_host_thread"); 
+ } 
+ } 
+ 
+ ret = host_tcp_medium->ma_driver->device_connect(on); 
+ 
+ return ret; 
+} 
+ 
+int mausb_tcp_host_init(void) 
+{ 
+ host_tcp_medium = alloc_init_mausb_tcp_medium(MAUSB_TCP_HOST); 
+ if (NULL == host_tcp_medium) 
+ return -ENOMEM; 
+ 
+ host_tcp_medium->addr_in.sin_addr.s_addr = htonl(0); 
+ 
+ host_tcp_medium->connect = &mausb_tcp_host_connect; 
+ 
+ host_tcp_medium->ma_driver = mausb_register_ms_driver(&ms_driver); 
+ 
+ return 0; 
+ 
+} 
+module_init(mausb_tcp_host_init); 
+ 
+void mausb_tcp_host_exit(void) 
+{ 
+ free_mausb_tcp_medium(host_tcp_medium, MAUSB_TCP_HOST); 
+} 
+module_exit(mausb_tcp_host_exit); 
+ 
+MODULE_LICENSE("Dual BSD/GPL"); 
+MODULE_AUTHOR("Intel"); 
+MODULE_DESCRIPTION("mausb_tcp_host"); 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_tx.c linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_tx.c
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_tx.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_tx.c	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,316 @@
+/* Name: mausb_tx.c 
+ * Description: Common functions for both host and device media agnostic 
+ * transfers. 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+#include "mausb_pkt.h" 
+#include "mausb_tx.h" 
+#include "mausb_const.h" 
+ 
+int mausb_transfer_data_pkt(struct mausb_pkt *pkt, struct mausb_host_ep *ep, 
+ gfp_t mem_flags) 
+{ 
+ int ret; 
+ 
+ ret = mausb_pkt_fill_ms_pkt(pkt, mem_flags); 
+ if (0 > ret) 
+ return ret; 
+ 
+ return mausb_transfer_packet(&pkt->pkt, &ep->tx_pair.to_ms); 
+ 
+} 
+EXPORT_SYMBOL(mausb_transfer_data_pkt); 
+ 
+/** 
+ * Opens an endpoint-specific connection between the media specific and media 
+ * agnostic drivers in order to send and receive MA USB data packets. 
+ * 
+ * @drv: Media specific driver to establish connection with. 
+ * @ep: Host endpoint to be associated with this channel. 
+ * @transfer_pkt: The call the MS driver should make when a packet is received. 
+ */ 
+int mausb_add_data_channel(struct mausb_ms_drv *drv, struct mausb_host_ep *ep, 
+ int (*transfer_pkt)(struct ms_pkt *pkt, void *context)) 
+{ 
+ int ret = 0; 
+ struct mausb_transfer_pair tx_pair; 
+ 
+ matx_dbg("%s: adding channel for ep with handle %x\n", __func__, 
+ ep->ep_handle.handle); 
+ 
+ tx_pair.to_ma.transfer_packet = transfer_pkt; 
+ tx_pair.to_ma.context = ep; 
+ tx_pair.pkt_sent = NULL; 
+ tx_pair.handle = ep->ep_handle.handle; 
+ 
+ ret = drv->ops->add_transfer_pair(&tx_pair); 
+ 
+ if (ret >= 0) 
+ ep->tx_pair = tx_pair; 
+ 
+ return ret; 
+} 
+EXPORT_SYMBOL(mausb_add_data_channel); 
+ 
+/** 
+ * Determines if conditions are met to complete a data transfer. 
+ * 
+ * @tx_state: State of transfer to be checked. 
+ * @seq_num: Sequence number to be compared to last sequence number in the 
+ * transfer. 
+ * 
+ * Returns true if a transfer can be considered complete or false otherwise. 
+ * Note that this does not differentiate between transfers that complete 
+ * with and without an error. 
+ */ 
+bool mausb_transfer_is_complete(struct mausb_transfer_state *tx_state, 
+ u8 seq_num) 
+{ 
+ bool complete = false; 
+ 
+ if (!tx_state->transfer_error && tx_state->last_transfer_sn <= seq_num) 
+ complete = true; 
+ 
+ if (tx_state->transfer_error) { 
+ matx_err("%s: transfer ending with error\n", __func__); 
+ complete = true; 
+ } 
+ 
+ return complete; 
+} 
+EXPORT_SYMBOL(mausb_transfer_is_complete); 
+ 
+/** 
+ * Deletes packet from endpoint list and frees memory. 
+ * 
+ * @ep: Endpoint associated with packet to be dropped. 
+ * @pkt: Packet to be dropped. 
+ */ 
+void mausb_drop_packet(struct mausb_host_ep *ep, struct mausb_pkt *pkt) 
+{ 
+ if (ep == NULL || pkt == NULL) 
+ return; 
+ 
+ list_del(&pkt->pkt_list); 
+ mausb_free_pkt(pkt); 
+ 
+ if (list_empty(&ep->req_list)) 
+ INIT_LIST_HEAD(&ep->req_list); 
+ 
+ if (list_empty(&ep->resp_list)) 
+ INIT_LIST_HEAD(&ep->resp_list); 
+} 
+EXPORT_SYMBOL(mausb_drop_packet); 
+ 
+/** 
+ * Deletes all of the packets based on the sequence number. 
+ * 
+ * @ep: Endpoint associated with transfer. 
+ * @seq_num: The sequence number of the packets to delete. This will 
+ * delete all the packets with sequence numbers up to 
+ * (but not including) seq_num. 
+ * @req_id: The request ID of the packets to delete. This will 
+ * delete all the packets with request IDs up to 
+ * (but not including) req_id. 
+ */ 
+void mausb_cleanup_ma_packets(struct mausb_host_ep *ep, u32 seq_num, u8 req_id) 
+{ 
+ struct mausb_pkt *active, *next; 
+ 
+ list_for_each_entry_safe(active, next, &ep->req_list, pkt_list) { 
+ if (mausb_seq_num_lt(active->data->seq_num, seq_num) || 
+ mausb_req_id_lt(active->data->req_id, req_id)) 
+ mausb_drop_packet(ep, active); 
+ } 
+ 
+ list_for_each_entry_safe(active, next, &ep->resp_list, pkt_list) { 
+ if (mausb_seq_num_lt(active->data->seq_num, seq_num) || 
+ mausb_req_id_lt(active->data->req_id, req_id)) 
+ 
+ mausb_drop_packet(ep, active); 
+ } 
+} 
+EXPORT_SYMBOL(mausb_cleanup_ma_packets); 
+ 
+/** 
+ * Resend all packets starting from a given sequence number. 
+ * 
+ * @ep: Endpoint associated with packets. 
+ * @pkt_list: Head of list of packets to search. 
+ * @seq_num: Sequence number of first packet to be sent. 
+ * 
+ * Returns 0 if at least one packet is sent, otherwise returns non-zero value. 
+ * Note: the caller should be holding the endpoint's spinlock. 
+ */ 
+int mausb_resend_multi_packets(struct mausb_host_ep *ep, 
+ struct list_head *pkt_list, 
+ u32 seq_num, unsigned long irq_flags) 
+{ 
+ int ret = -EINVAL; 
+ struct mausb_pkt *pkt; 
+ int i = 0; 
+ 
+ list_for_each_entry(pkt, pkt_list, pkt_list) { 
+ 
+ i++; 
+ if (mausb_seq_num_gt_eq(pkt->data->seq_num, seq_num)) { 
+ matx_dbg("%s: resending pkt %i\n", __func__, 
+ pkt->data->seq_num); 
+ pkt->common->ver_flags |= MAUSB_PKT_FLAG_RETRY; 
+ ret = 0; 
+ mausb_transfer_data_pkt(pkt, ep, GFP_ATOMIC); 
+ } 
+ } 
+ 
+ return ret; 
+} 
+EXPORT_SYMBOL(mausb_resend_multi_packets); 
+ 
+/** 
+ * Checks to see if a received packet is a retry and resends response packets 
+ * (if found). 
+ * 
+ * @ep: Endpoint associated with transfer. 
+ * @pkt_list: List of packets previously sent. 
+ * @pkt: Received packet. 
+ * 
+ * Returns true if received packet has the Retry flag set AND at least one 
+ * response packet was found and sent. Returns false if the Retry flag not 
+ * set or the Retry flag is set but no corresponding packets have been found. 
+ */ 
+bool mausb_is_a_retry(struct mausb_host_ep *ep, struct list_head *pkt_list, 
+ struct mausb_pkt *pkt) 
+{ 
+ int err = 0; 
+ unsigned long irq_flags; 
+ 
+ spin_lock_irqsave(&ep->ep_lock, irq_flags); 
+ if (pkt->common->ver_flags & MAUSB_PKT_FLAG_RETRY) { 
+ matx_dbg("%s: packet is a retry\n", __func__); 
+ 
+ /* 
+ * If received packet is a retry, look to see if we've 
+ * already generated the corresponding packets. 
+ */ 
+ err = mausb_resend_multi_packets(ep, pkt_list, 
+ pkt->data->seq_num, 
+ irq_flags); 
+ 
+ /* 
+ * Only return true if packet is found, otherwise we might 
+ * miss responding to a packet we never received. 
+ */ 
+ if (err == 0) 
+ return true; 
+ } 
+ spin_unlock_irqrestore(&ep->ep_lock, irq_flags); 
+ 
+ return false; 
+} 
+EXPORT_SYMBOL(mausb_is_a_retry); 
+ 
+/** 
+ * Called by timeout timer to start thread that handles error handling and 
+ * packet resends. 
+ * 
+ * Used to avoid passing packets to a medium while in an interrupt context, 
+ * which can be problematic for some mediums. 
+ */ 
+void wake_timeout_thread(unsigned long _ep) 
+{ 
+ struct mausb_host_ep *ep = (struct mausb_host_ep *) _ep; 
+ unsigned long irq_flags; 
+ 
+ matx_dbg("%s: timeout occurred!!!\n", __func__); 
+ 
+ spin_lock_irqsave(&ep->ep_lock, irq_flags); 
+ ep->tx_timed_out = true; 
+ spin_unlock_irqrestore(&ep->ep_lock, irq_flags); 
+ wake_up_interruptible(&ep->host_ep_wq); 
+} 
+ 
+/** 
+ * Fills packet fields based on the given EP. Also fills device fields. 
+ */ 
+void mausb_fill_pkt_ep(struct mausb_pkt *pkt, struct mausb_host_ep *ma_ep) 
+{ 
+ struct mausb_dev *mausb_dev; 
+ struct ma_dev *ma_dev; 
+ unsigned long irq_flags; 
+ 
+ spin_lock_irqsave(&ma_ep->ep_lock, irq_flags); 
+ 
+ if (MAUSB_EP_HANDLE_ACTIVE != ma_ep->ep_handle_state) { 
+ matx_warn("%s: endpoint handle not active\n", __func__); 
+ } 
+ 
+ pkt->common->ep_handle = ma_ep->ep_handle; 
+ pkt->data->eps_tflags |= ma_ep->ep_handle_state; 
+ /* TODO: set transfer Type */ 
+ 
+ mausb_dev = ma_ep->mausb_dev; 
+ spin_unlock_irqrestore(&ma_ep->ep_lock, irq_flags); 
+ 
+ 
+ spin_lock_irqsave(&mausb_dev->dev_lock, irq_flags); 
+ ma_dev = mausb_dev->ma_dev; 
+ spin_unlock_irqrestore(&mausb_dev->dev_lock, irq_flags); 
+ 
+ 
+ spin_lock_irqsave(&ma_dev->ma_dev_lock, irq_flags); 
+ pkt->common->ma_dev_addr = ma_dev->ma_dev_addr; 
+ pkt->common->mass_id = ma_dev->mass_id; 
+ spin_unlock_irqrestore(&ma_dev->ma_dev_lock, irq_flags); 
+} 
+EXPORT_SYMBOL(mausb_fill_pkt_ep); 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_tx-device.c linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_tx-device.c
